### Praat Stimmprofil
# Joerg Mayer, jmayer@lingphon.net
# This is free software under the terms of the GNU General Public License 3

endeditor



### read general data
gdata$ = readFile$ (defaultDirectory$ + "/stimmprofil0")
untersucher$ = extractLine$ (gdata$, "untersucher: ")
datum$ = extractLine$ (gdata$, "datum: ")
mikrophon$ = extractLine$ (gdata$, "mikrophon: ")
aD_Wandler$ = extractLine$ (gdata$, "aD_Wandler: ")
aD_Parameter$ = extractLine$ (gdata$, "aD_Parameter: ")
computer$ = extractLine$ (gdata$, "computer: ")
betriebssystem$ = extractLine$ (gdata$, "betriebssystem: ")
name$ = extractLine$ (gdata$, "name: ")
geburtsdatum$ = extractLine$ (gdata$, "geburtsdatum: ")
geschlecht = extractNumber (gdata$, "geschlecht:")
befund$ = extractLine$ (gdata$, "befund: ")

### fetch version
version$ = readFile$ (defaultDirectory$ + "/VERSION")
space = index (version$, " ")
pspversion$ = left$ (version$, space-1)

### adapt some variables
tech_data = 0
if geschlecht = 1
	anrede$ = "Frau "
else
	anrede$ = "Herr "
endif
if mikrophon$ <> ""
	mikrophon$ = mikrophon$ + "     "
	tech_data = 1
else
	mikrophon$ = "k.A.     "
endif
if computer$ <> ""
	computer$ = computer$ + "     "
	tech_data = 1
else
	computer$ = "k.A.     "
endif
if betriebssystem$ <> ""
	betriebssystem$ = betriebssystem$ + "     "
else
	betriebssystem$ = "k.A.     "
endif
if aD_Parameter$ <> ""
	aD_Parameter$ = aD_Parameter$
	tech_data = 1
else
	aD_Parameter$ = "k.A."
endif
if aD_Wandler$ <> ""
	aD_Wandler$ = aD_Wandler$ + "     "
	tech_data = 1
else
	aD_Wandler$ = "k.A.     "
endif
if tech_data
	tech_data$ = "Computer: " + computer$ + "OS: " + betriebssystem$ + "Mikrophon: " + mikrophon$ + "AD-Wandler: " + aD_Wandler$ + "AD-Parameter: " + aD_Parameter$
else
	tech_data$ = ""
endif

### initialize output
Erase all
Font size: 10
Helvetica
Colour: "Black"
Solid line

### output: logo
Select inner viewport: 0.58, 7.7, 0.58, 1.58
Axes: 0, 5, 0, 1
# Colour: "Maroon"
Colour: "Black"
Text special: 0.75, "centre", 0.72, "half", "Helvetica", 14, "0", "##Praat-Stimmprofil#"
Line width... 3
Draw rounded rectangle: 0, 1.5, 0.35, 1, 3.0
Text special: 0.75, "centre", 0.54, "half", "Helvetica", 6, "0", "Stimmprofil " + pspversion$ + " / Praat v" + praatVersion$
Colour: "Black"

### output: header
Line width... 1
Text special: 1.8, "left", 1, "top", "Helvetica", 9, "0", "##Name:# "
Text special: 2.5, "left", 1, "top", "Helvetica", 9, "0", anrede$ + name$
Text special: 1.8, "left", 0.85, "top", "Helvetica", 9, "0", "##Geburtsdatum:# "
Text special: 2.5, "left", 0.85, "top", "Helvetica", 9, "0", geburtsdatum$
Text special: 1.8, "left", 0.7, "top", "Helvetica", 9, "0", "##Befund:# "
Text special: 2.5, "left", 0.7, "top", "Helvetica", 9, "0", befund$

# Colour: "Maroon"
Colour: "Black"
Text special: 1.8, "left", 0.3, "bottom", "Helvetica", 8, "0", "##Datum:# " + datum$ + "        ##Untersucher:# " + untersucher$
Colour: "Black"
Text special: 5, "right", 0.29, "top", "Helvetica", 6, "0", tech_data$
Draw line: 1.8, 0.51, 5, 0.51


### output: grid layout
Select inner viewport: 0.58, 7.7, 2.5, 11
Axes... 0 6 0 10
Draw rectangle... 0 6 0.1 10
# footnote 1
Text special: 0, "left", 0.1, "top", "Helvetica", 6, "0", "^* Stimmabbrüche und AVQI / ABI werden nur bei geeigneten Stimmproben berechnet."
# draw lines
Line width... 1
Colour: "Black"
# horizontal
Draw line: 0, 8.35, 6, 8.35
Draw line: 0, 6.7, 6, 6.7
Draw line: 0, 5.05, 6, 5.05
Draw line: 0, 3.4, 6, 3.4
Draw line: 0, 1.75, 6, 1.75
# vertical
Draw line: 3, 6.7, 3, 5.05
Draw line: 3, 3.4, 3, 1.75

